import java.util.*;
import java.math.BigInteger;
import java.io.*;

public class ProjetCrypto {
	//Fourni par Thomas
	/*public static void main (String args[]) {
		// arg0 : n, arg1 : e, arg2(optionnel _ defaut : 0) : le mode
 		if (args.length < 2) {
			System.out.println("Erreur dans l'entrée :\nargument 1 : n\nargument 2 : e\nargument 3 (optionnel) : mode d'attaque (0 - 2) (par défaut : 0)");
			System.out.println("Autres modes :\n\t1 - Seconde initialisation de Wiener\n\t2 - Générations d'initialisateurs par boucle");
			return;
		}
		
		int mode = (args.length > 2) ? (args[2].charAt(0) - '0') : 0;

	}*/
	public static BigInteger extraitFichier(String nomFichier)
	{
		BufferedReader lecteurAvecBuffer = null;
		String ligne;
		try
		{
			lecteurAvecBuffer = new BufferedReader(new FileReader(nomFichier));
			ligne = lecteurAvecBuffer.readLine();
			lecteurAvecBuffer.close();
			return new BigInteger(ligne);
		} catch(FileNotFoundException exc) {
			System.out.println("Erreur d'ouverture de fichier");
		} catch(IOException exc) {
			System.out.println("Erreur de lecture du fichier");
		}
		return null;
	}

	public static void main (String args[])  {
		if (args.length == 0) {
			System.out.println("Erreur : vous devez préciser les données en entrées (les deux composantes de la clé publique sont nécessaires ou alors mode aléatoire) :");
			System.out.println("   'n' suivi d'un nombre spécifiant le modulo de la clé publique");
			System.out.println("   'N' suivi d'un fichier contenant le modulo de la clé publique");
			System.out.println("   'e' suivi d'un nombre spécifiant l'exposant public");
			System.out.println("   'E' suivi d'un fichier contenant l'exposant public");
			System.out.println("   'r' suivi d'un nombre génère de manière aléatoire p et de la taille spécifiée en bits; e aléatoire tel que l'attaque de Wiener fonctionne");
			System.out.println("   'm' suivi d'un nombre (0 : de base, 1 : amélioration 1, 2 : amélioration 2)");
			
			return;
		}
		BigInteger n=null,e=null;
		int mode=0;
		try {
		switch (args[0].charAt(0))
		{
			case 'n':
				n = new BigInteger(args[1]);
				break;
			case 'N':
				n = extraitFichier(args[1]);
				break;
			case 'e':
				e = new BigInteger(args[1]);
				break;
			case 'E':
				e = extraitFichier(args[1]);
				break;
			case 'm':
				mode = args[1].charAt(0) - '0';
				break;
			case 'r': //mode aléatoire
				BigInteger p = BigInteger.probablePrime(new Integer(args[1]), new Random());
				BigInteger q = BigInteger.probablePrime(new Integer(args[1]), new Random());
				n = p.multiply(q);
				BigInteger d = new BigInteger((new Integer(args[1]))/4, new Random()); 
				BigInteger phi_n = (p.subtract(BigInteger.ONE)).multiply(q.subtract(BigInteger.ONE));
				e = d.modInverse(phi_n);
				break;
			default :
				System.err.println("Erreur dans la saisie des données d'entrée");
				return;

		}
		if (args.length > 2) {
			switch (args[2].charAt(0))
			{
				case 'n':
					n = new BigInteger(args[3]);
					break;
				case 'N':
					n = extraitFichier(args[3]);
					break;
				case 'e':
					e = new BigInteger(args[3]);
					break;
				case 'E':
					e = extraitFichier(args[3]);
					break;
				case 'm':
					mode = args[3].charAt(0) - '0';
					break;
				default :
					System.err.println("Erreur dans la saisie des données d'entrée");
					return;
			}
		}		
		if (args.length > 4)
		{
			switch (args[4].charAt(0))
			{
				case 'n':
					n = new BigInteger(args[5]);
					break;
				case 'N':
					n = extraitFichier(args[5]);
					break;
				case 'e':
					e = new BigInteger(args[5]);
					break;
				case 'E':
					e = extraitFichier(args[5]);
					break;
				case 'm':
					mode = args[5].charAt(0) - '0';
					break;
				default :
					System.err.println("Erreur dans la saisie des données d'entrée");
					return;
		}
		}	
		} catch (Exception t) {
			System.err.println("Nombre d'arguments incorrects (il doit y avoir un nombre pair>=2 !)");
			return;
		}
		if ((n==null)||(e==null))
		{
			System.err.println("Arguments incorrects (il doit y avoir un nombre pair>=2 !)");
			return;		
		}
		try {
			casseur toto = new casseur(n, e);
			Reponse r = toto.casser(mode);
			System.out.println(r);
		}
		catch (Exception t) {
			System.out.println(e);
		}
	}
}
