import java.math.BigInteger;
import java.util.LinkedList;

class Reponse {
	public BigInteger p, q, d, n, e;
	Reponse() {p = BigInteger.ZERO; q = BigInteger.ZERO; d = BigInteger.ZERO; n = BigInteger.ZERO; e = BigInteger.ZERO;}
	public String toString() {return ("Pour n = " + this.n.toString() + " et e = " + this.e.toString() + "\non a :\np = " + this.p.toString() + "\nq = " + this.q.toString() + "\nexposant secret d = " + this.d.toString());}
}

public class casseur {
	casseur(BigInteger nn, BigInteger ee) {n = nn; e = ee;
	if (n.mod(new BigInteger("2")).compareTo(BigInteger.ZERO) == 0) throw new Error ("votre n est pair !!");}
	
	private BigInteger n, e, ri, ri_moins_un; // i réfère à m_etap ; ri : les derniers restes calculés
	private int m_etap; // (q0, q1, ... qm_etap) : le début du développement en fractions continues qui a été calculé
	private LinkedList<BigInteger> qi, ni, di; // les variables de l'article de Wiener
	
	public Reponse casser(int mode) throws Exception {
		BigInteger nume = null, denomi = null;
		int maxi = 1;
		if (mode == 0) {				// DE BASE
			nume = e.mod(n);
			denomi = n;
		}
		else if (mode == 1) { 		// IMPROVEMENT N°2
			BigInteger racine_n = sqrt(n);
			nume = (racine_n.subtract(BigInteger.ONE)).multiply((racine_n.subtract(BigInteger.ONE)));
			denomi =	(racine_n.subtract(BigInteger.ONE)).multiply((racine_n.subtract(BigInteger.ONE)));
		}
		else if (mode==2) {		// IMPROVEMENT N°3
			nume = e.mod(n);
			denomi = n;
			maxi = 100;
		}
		else {			
		}
		
		for(int i = 0; i < maxi; i++) {
			// mode = 4
			try {
				return breaker(nume, denomi);
			}
			catch (Exception e) {;}
			if (mode == 2) {nume = nume.add(BigInteger.ONE); denomi = denomi.add(BigInteger.ONE);}
		}
		throw new Exception("Clef incassable");
	}
	
	public Reponse breaker(BigInteger nume, BigInteger denomi) throws Exception {
		Reponse retour = new Reponse();
		initialiser();
		while(true) {
			try {
				calcul_next(nume, denomi);
				System.out.println("fraction approchée à l'etape " + m_etap + " :\n\t" + ni.getLast() + "\t/\t" + di.getLast() + "\n");
				if (Verifier(retour))
					return retour;
			}
			catch (Exception e) {throw new Exception("Clef incassable");}
		}
	}
	
	
	private void initialiser() {
		m_etap = -1;
		qi = new LinkedList<BigInteger>();
		ni = new LinkedList<BigInteger>();
		di = new LinkedList<BigInteger>();
	}
	
	private void calcul_next(BigInteger num_depart, BigInteger denom_depart) throws Exception {
		if (m_etap == -1) {
			qi.add(BigInteger.ZERO);
			ri = num_depart; // e.mod(n); A LA BASE
			ri_moins_un = denom_depart; // n; A LA BASE
			ni.add(BigInteger.ZERO);
			di.add(BigInteger.ONE);
			m_etap++;
			return;
		}
		
		if (ri.compareTo(BigInteger.ZERO) == 0)
			throw new Exception("fin du développement");
		
		qi.add(ri_moins_un.divide(ri));
		BigInteger r = ri_moins_un.mod(ri);
		ri_moins_un = ri;
		ri = r;
		
		if (m_etap == 0) {
			ni.add(BigInteger.ONE);
			di.add(qi.getLast());
		}
		else {
			BigInteger nlast = ni.get(m_etap);
			BigInteger nlastmoinsun = ni.get(m_etap - 1);
			ni.add((qi.getLast().multiply(nlast)).add(nlastmoinsun));
			
			BigInteger dlast = di.get(m_etap);
			BigInteger dlastmoinsun = di.get(m_etap - 1);
			di.add((qi.getLast().multiply(dlast)).add(dlastmoinsun));
		}
		m_etap++;
	}
	
	private boolean Verifier(Reponse retour) {
		BigInteger numerateur, denominateur; // guess k et guess dg
		if (m_etap == 0) {
			numerateur = BigInteger.ONE;
			denominateur = BigInteger.ONE;
		}
		else if (m_etap % 2 == 0) {
			BigInteger nlast = ni.get(m_etap-1);
			BigInteger nlastmoinsun = ni.get(m_etap-2);
			BigInteger dlast = di.get(m_etap-1);
			BigInteger dlastmoinsun = di.get(m_etap-2);
			numerateur = ((qi.getLast().add(BigInteger.ONE)).multiply(nlast)).add(nlastmoinsun);
			denominateur = ((qi.getLast().add(BigInteger.ONE)).multiply(dlast)).add(dlastmoinsun);
		}
		else {
			numerateur = ni.getLast();
			denominateur = di.getLast();
		}
		
		BigInteger edg = e.multiply(denominateur);
		BigInteger p_moinsun_q_moinsun = edg.divide(numerateur);
		BigInteger guess_g = edg.mod(numerateur);
		
		if (guess_g.compareTo(BigInteger.ZERO) == 0)
			return false;
		
		BigInteger guess_p_plus_q = (n.add(BigInteger.ONE)).subtract(p_moinsun_q_moinsun);
		if (guess_p_plus_q.getLowestSetBit() == 0) // cas où p+q impair
			return false;
		BigInteger guess_p_moins_q_sur_2_carre = ((guess_p_plus_q.shiftRight(1)).multiply(guess_p_plus_q.shiftRight(1))).subtract(n);
		BigInteger guess_p_moins_q_sur_2 = sqrt(guess_p_moins_q_sur_2_carre);
		if ((guess_p_moins_q_sur_2.multiply(guess_p_moins_q_sur_2)).compareTo(guess_p_moins_q_sur_2_carre) != 0)
			return false;
		retour.p = guess_p_moins_q_sur_2.add(guess_p_plus_q.shiftRight(1)); 
		retour.q = (guess_p_plus_q.shiftRight(1)).subtract(guess_p_moins_q_sur_2);
		retour.d = denominateur.divide(guess_g);
		retour.n = n;
		retour.e = e;
		return true;
	}
	
	//    "Racine carrée" entière : sqrt(x) renvoie le plus grand entier a tq a^2<=x
	static BigInteger sqrt(BigInteger x) {
		int nb = x.bitLength() ;
		BigInteger a , b ;
		a = (BigInteger.ONE).shiftLeft((nb+1)/2) ;
		do {
			b = a ;
			a = x.divide(a).add(a);
			a = a.shiftRight(1) ;
		} while (a.compareTo(b) < 0) ;
		return b ;
	}
	
}